﻿using SqlSugar;
using XF.Domain.Entities;

namespace FileStorage.Repository.SqlSugar.Extensions
{
    public static class SqlSugarRepositoryExtensions
    {
        public static async Task<(int Total, List<TEntity> Items)> ToPagedListAsync<TEntity>(this ISugarQueryable<TEntity> query, int pageIndex, int pageSize, CancellationToken cancellationToken = default)
            where TEntity : class, IEntity<string>, new()
        {
            RefAsync<int> total = 0;
            var items = await query.ToPageListAsync(pageIndex, pageSize, total);
            return (total.Value, items);
        }

        //public static async Task<(int Total, List<TEntity> Items)> ToPagedListAsync<TEntity>(this ISugarQueryable<TEntity> query, PagedRequest dto, CancellationToken cancellationToken = default)
        //    where TEntity : class, IEntity<string>, new()
        //{
        //    RefAsync<int> total = 0;
        //    var items = await query.ToPageListAsync(dto.PageIndex, dto.PageSize, total);
        //    return (total.Value, items);
        //}
    }
}
